\documentclass[12pt]{article}
\usepackage{graphicx}
\usepackage{epstopdf}
\usepackage{amssymb}


\def\ga{\alpha}
\def\gb{\beta}
\def\gc{\gamma}
\def\gd{\delta}
\def\ge{\epsilon}
\def\gz{\zeta}
\def\gy{\eta}
\def\th{\theta}
\def\gi{\iota}
\def\gk{\kappa}
\def\gl{\lambda}
\def\gm{\mu}
\def\gn{\nu}
\def\gx{\xi}
\def\gp{\pi}
\def\gr{\rho}
\def\gs{\sigma}
\def\gt{\tau}
\def\gu{\upsilon}
\def\ph{\phi}
\def\ch{\chi}
\def\ps{\psi}
\def\gw{\omega}

\def\gB{\Beta}
\def\gC{\Gamma}
\def\gD{\Delta}
\def\Th{\Theta}
\def\gL{\Lambda}
\def\gX{\Xi}
\def\gP{\Pi}
\def\gS{\Sigma}
\def\gU{\Upsilon}
\def\Ph{\Phi}
\def\Ps{\Psi}
\def\gW{\Omega}

\def\bA{{\bf A}}
\def\bB{{\bf B}}
\def\bC{{\bf C}}
\def\bD{{\bf D}}
\def\bE{{\bf E}}
\def\bF{{\bf F}}
\def\bG{{\bf G}}
\def\bH{{\bf H}}
\def\bI{{\bf I}}
\def\bJ{{\bf J}}
\def\bK{{\bf K}}
\def\bL{{\bf L}}
\def\bM{{\bf M}}
\def\bN{{\bf N}}
\def\bO{{\bf O}}
\def\bP{{\bf P}}
\def\bQ{{\bf Q}}
\def\bR{{\bf R}}
\def\bS{{\bf S}}
\def\bT{{\bf T}}
\def\bU{{\bf U}}
\def\bV{{\bf V}}
\def\bW{{\bf W}}
\def\bX{{\bf X}}
\def\bY{{\bf Y}}
\def\bZ{{\bf Z}}

\def\cA{{\cal A}}
\def\cB{{\cal B}}
\def\cC{{\cal C}}
\def\cD{{\cal D}}
\def\cE{{\cal E}}
\def\cF{{\cal F}}
\def\cG{{\cal G}}
\def\cH{{\cal H}}
\def\cI{{\cal I}}
\def\cJ{{\cal J}}
\def\cK{{\cal K}}
\def\cL{{\cal L}}
\def\cM{{\cal M}}
\def\cN{{\cal N}}
\def\cO{{\cal O}}
\def\cP{{\cal P}}
\def\cQ{{\cal Q}}
\def\cR{{\cal R}}
\def\cS{{\cal S}}
\def\cT{{\cal T}}
\def\cU{{\cal U}}
\def\cV{{\cal V}}
\def\cW{{\cal W}}
\def\cX{{\cal X}}
\def\cY{{\cal Y}}
\def\cZ{{\cal Z}}


\def\ba{{\bf a}}
\def\bb{{\bf b}}
\def\bc{{\bf c}}
\def\bd{{\bf d}}
\def\be{{\bf e}}
\def\bg{{\bf g}}
\def\bh{{\bf h}}
\def\bi{{\bf i}}
\def\bj{{\bf j}}
\def\bk{{\bf k}}
\def\bl{{\bf l}}
\def\bm{{\bf m}}
\def\bn{{\bf n}}
\def\bo{{\bf o}}
\def\bp{{\bf p}}
\def\bq{{\bf q}}
\def\br{{\bf r}}
\def\bs{{\bf s}}
\def\bt{{\bf t}}
\def\bu{{\bf u}}
\def\bv{{\bf v}}
\def\bw{{\bf w}}
\def\bx{{\bf x}}
\def\by{{\bf y}}
\def\bz{{\bf z}}

\def\b0{{\bf0}}
\def\o{\circ}
\def\x{\times}
\def\d{\partial}
\def\<{\langle}
\def\>{\rangle}
\def\R{{\mathbb R}}
\def\Z{{\mathbb Z}}
\def\Q{{\mathbb Q}}
\def\N{{\mathbb N}}
\def\C{{\mathbb C}}
\def\T{{\mathbb T}}
\def\Cinf{C^\infty}
\def\sb{\subseteq}
\def\sp{\superseteq}
\def\({\left(}
\def\){\right)}
\def\rank{\mbox{rank}\,}
\def\rk{\mbox{rank}\,}
\def\ddt{\frac d{dt}}
\def\corank{\mbox{corank}\,}
\def\cl{\hbox{cl}\,}
\def\im{\hbox{im}\,}
\def\Id{\hbox{Id}}
\def\Diff{\hbox{Diff}}
\def\tv{\pitchfork}
\def\ntv{\not\tv}
\def\codim{\hbox{codim}\,}
\def\tr{\hbox{tr}\,}
\def\cosec{\hbox{cosec}\,}
\def\const{\hbox{const}}
\def\lc{\lceil}
\def\rc{\rceil}
\def\lf{\lfloor}
\def\rf{\rfloor}
\def\sech{\hbox{sech}\,}
\def\csch{\hbox{csch}\,}
\def\grad{\hbox{grad}\,}
\def\nbhd{neighbourhood}
\def\dlim{\displaystyle\lim}
\def\dfrac#1#2{\displaystyle{#1\over#2}}
\def\dsum{\displaystyle\sum}
\def\dint{\displaystyle\int}
\def\diint{\displaystyle\iint}
\def\diiint{\displaystyle\iiint}
\def\doint{\displaystyle\oint}
\def\tlim{\textstyle\lim}
\def\tfrac#1#2{\textstyle{#1\over#2}}
\def\tsum{\textstyle\sum}
\def\tint{\textstyle\int}
\def\del{\nabla}
\def\div{\hbox{div}\,}
\def\curl{\hbox{curl}\,}
\def\intL{\int\limits}
\def\iintL{\iint\limits}
\def\iiintL{\iiint\limits}

\def\abs{\hbox{abs}\,}
\def\sgn{\hbox{sgn}\,}
\def\dom{\hbox{dom}\,}


\def\eval{\,\Bigl.\Bigl|}



\def\drawbox#1{\lower6pt\hbox{{\vbox{\hrule\hbox{\vrule\kern15pt
   \vbox{\kern10pt\vbox{\hbox{#1}}\kern10pt} 
   \kern18pt\vrule}\hrule}}}}

\def\picture #1 by #2 (#3){
  \medbreak
		$$\vbox to #2{
    \hrule width #1 height 0pt depth 0pt
    \vfill
    \special{picture #3}
  }$$
}

\def\scaledpicture #1 by #2 (#3 scaled #4){
  \dimen0=#1 
		\dimen1=#2
  \divide\dimen0 by 1000 
   \multiply\dimen0 by #4
  \divide\dimen1 by 1000 
   \multiply\dimen1 by #4
  \picture \dimen0 by \dimen1 (#3 scaled #4)}
%\input mypars
%The following are plain tex style parameters 

\baselineskip=12pt
\hoffset=0pt
\voffset=0 cm
\leftskip=0pt
\rightskip=0pt
\parindent=0cm

%And these are latex style parameters

\headsep=0cm
\headheight=0cm
\evensidemargin=0cm
\oddsidemargin=0cm
\parskip=12pt
\textwidth=16.5 true cm
\textheight=22 true cm
\topmargin=0cm


\def\Gr{Gr\"obner }
\def\kn{k[x_1,\dots,x_n]}

\newtheorem{theorem}{Theorem}
\newtheorem{lemma}{Lemma}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]

\newenvironment{proof}
{\begin{trivlist}
\item[\hskip \labelsep {\bf Proof.}]
}
{\hfill$\Box$
\end{trivlist}}
           

\def\pagenumbers{\headline={\iftitle\hfil\global\titlefalse                     
   \else\hss\rm\folio\hss\fi}}                                                  
\newtoks\option                                                                 
\newtoks\solnhead                                                               
\newtoks\sheetname                                                              
\option={,}                                                                     
\def\separate#1,#2@{\def\optionid{#1}\def\optionname{#2}}                      
\def\fullwidth{\everypar{}\parindent=0pt\relax}                                 

\def\maketitle{
\begin{center}
{\sc Victoria University of Wellington\\
School of Mathematics, Statistics and Operations Research}\\
\smallskip
{\sl
Te Kura M{\=a}tai Tatauranga, Rangahau P{\=u}naha}
\end{center}
\expandafter\separate\the\option@
\hbox to\hsize{\hrulefill}
\nointerlineskip
\vskip3pt                                  
\hbox
to\hsize{\strut\rlap{\optionid}\hfill{\sc\optionname}\hfill\llap{\number\year}}          
\nointerlineskip
\vskip2pt
\hbox to\hsize{\hrulefill}}

\let\filbreak=\relax                                                           
\def\head{\filbreak\vskip 18pt\fullwidth                                    
   \def\filbreak{\global\let\filbreak=\fillbreak}%                            
   \centerline{\large\bf \the\sheetname}\nobreak
   \vskip 12pt minus 3pt}                                                       
\def\tutorial{\sheetname={Tutorial}\head}                                      
\def\assignment{\sheetname={Assignment}\head}                                  
\def\sheet#1{\sheetname={#1}\head}                                             
\def\showdue#1{\hbox to\hsize{\hfil Due: #1}
\vskip 5pt minus 3pt}

\leftmargin=0pt              

\begin{document}

\option={MATH 437,Gr\"obner Bases and Their Applications}        
\maketitle
\medskip 
\setcounter{section}0
\section{Polynomial Equations}

\subsection{Introduction}

This course is in a branch of Algebraic Geometry.  At the heart of classical
algebraic geometry is an attempt to understand solution sets of polynomial
equations in one or more variables by means of a translation between geometry and
algebra.  Theoretical and practical problems of this nature abound and ideally
we would like an {\it effective\/} way of solving them, that is, an algorithm
which can be implemented on a computer.  The interest in this topic has grown
rapidly with the development of computer algebra systems such as Maple and
Mathematica. 

The underlying algebraic geometry dates back to the end of the 19th century and is
largely the work of David Hilbert.  We'll meet two key theorems of his---the Basis
Theorem and the Nullstellensatz, and also applications to the theory of invariants
for which he was also largely responsible.  The idea underlying a practical
algorithm is that of a Gr\"obner basis, not in fact the idea of its namesake
Wolfgang Gr\"obner, but originally introduced (under the name ``standard basis") by
the Japanese algebraic geometer Hironaka and then renamed by Bruno Buchberger, in
honour of his thesis supervisor, after Buchberger used them in his thesis to define
the foundational algorithm on which the theory rests.

As well as exploring the algorithm and its efficient implementation we shall also
examine some applications of the technique to a variety of problems: in invariant
theory, coding theory, graph theory, robotics etc.

\subsection{Applications and Examples}

{\em 1. Singularities.}   Find the critical points of the function $f:\R^3\to\R$, 
$$
f(x,y,z)=(x^2+y^2)(x^2+y^2-1)z+z^3+x+y.
$$
The solution is given by the simultaneous vanishing of the partial derivatives:
$$
f_x=f_y=f_z=0.
$$
In other words we need to solve 3~polynomial equations in 3~variables.

{\em 2. Optimisation.}  Maximise the function $f(x,y,z)=x^3+2xyz-z^2$ subject to the constraint
$g(x,y,z)=x^2+y^2+z^2-1=0$.  

The classical way of tackling constrained optimisation is via Lagrange
multipliers.  This leads in this case to the equations $\nabla f=\gl\nabla g$ and
$g=0$, where $\gl$ is a new variable. Explicitly:
\begin{eqnarray*}
3x^2+2yz-2x\gl&=&0\\
2xz-2y\gl&=&0\\
2xy-2z-2z\gl&=&0\\
x^2+y^2+z^2-1&=&0.
\end{eqnarray*}
Ideally we would like to find a way of eliminating variables systematically so that
we could solve these equations. The analogous problem involving only linear
equations is resolved by Gaussian elimination---in effect we replace the given
equations by new ones which describe the same set of solutions but are easier to
solve.

{\em 3. Robot kinematics.} The position of the end--effector
of a 3--component planar robot arm is given by the equations:

\vspace{-2.5in}
\centerline {
\includegraphics[width=10in]{robot_arm}
}
\vspace{-3in}


\begin{eqnarray*}
x&=&l_1\cos\th_1+(l_2+\ga)\cos(\th_1+\th_2)\\
y&=&l_1\sin\th_1+(l_2+\ga)\sin(\th_1+\th_2)
\end{eqnarray*}
where $\th_1,\th_2,\ga$ are input joint variables and $l_1,l_2$ are fixed design
parameters.  A standard problem in robotics is the {\it inverse kinematic
problem\/}, to find the joint variables which determine a given position of the
end--effector.  In other words, solve the equations for $\th_1,\th_2,\ga$ in terms
of $x,y$.   These equations are not polynomial but they can be so rendered by letting
$c_i=\cos\th_i$ and $s_i=\sin\th_i$, $i=1,2$, and deriving the system:
\begin{eqnarray*}
l_1c_1+(l_2+\ga)(c_1c_2-s_1s_2)&=&x\\
l_1s_1+(l_2+\ga)(s_1c_1+s_2c_2)&=&y\\
c_1^2+s_1^2&=&1\\
c_2^2+s_2^2&=&1
\end{eqnarray*}
giving a set of 4 polynomial equations in 5~variables. A more practical version of
this is to solve the inverse kinematic problem for a 6R spatial robot arm.  It has
been shown (using for example \Gr techniques) that the solutions can be reduced to
solving a 16th degree polynomial in one variable. Other similar problems arise in
the analysis of parallel robot mechanisms such as the Gough--Stewart platform (or
octahedral manipulator).

{\em 4. Fermat's Last Theorem.} Find rational solutions to the equation
$F_n(x,y,z)=x^n+y^n-z^n=0$ for $n\geq3$.  As we now know, no solution is possible,
but a related question arose in trying to prove the Theorem: does there exist $k$
such that for all $n>k$,
$$
F_n(x,y,z)=\sum_{i=1}^k h_{n,i}(x,y,z)F_i(x,y,z),
$$
where the $h_{n.i}$ are polynomials with {\it rational\/} coefficients.
The answer, it turns out, is ``yes", in fact for $k=3$. Notice that unlike the
previous examples where the coefficients lay in $\R$, we are now working over the
field $\Q$ of rationals.

{\em 5. Geometric Theorem Proving.}  

\vspace{-2.5in}
\centerline {
\includegraphics[width=10in]{pappus}
}
\vspace{-2.5in}

A famous theorem of planar (projective) geometry, due
to Pappus, states that given three points on each of two lines, the three points
arising from the intersections of the lines joining corresponding pairs of points
are collinear. 

This can be interpreted algebraically by expressing collinearity conditions in
terms of polynomial equations.  For example the condition that $(z_1,z_2)$ lies on
the line joining $(x_1,0)$ and $(y_5,y_6)$ is given by 
$$
p(x_1,x_2,x_3,y_1,\dots,y_6,z_1,\dots,z_6)=(z_1-x_1)y_6-(y_5-x_1)z_2=0.
$$
Thus the theorem can be interpreted as asserting that $c=0$ ($z$ points collinear)
is entailed by $p_1=\dots=p_7=0$.  Algebraically, we'll see that this reduces to
determining whether the constant polynomial~1 is in the {\it \Gr basis} for the set
of polynomials
$$
\{p_1,\dots,p_7,c.w-1\}
$$
where $w$ is a new variable.



\end{document}

